"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FsmInstance = exports.Fsm = void 0;
var is_empty_1 = __importDefault(require("is-empty"));
var errors_1 = require("./errors");
var state_1 = require("./state");
var Fsm = /** @class */ (function () {
    function Fsm() {
        this._states = {};
    }
    Object.defineProperty(Fsm.prototype, "states", {
        get: function () {
            return this._states;
        },
        enumerable: false,
        configurable: true
    });
    Fsm.prototype.addState = function (stateName, builder) {
        var state = new state_1.State(stateName);
        // const state: State<NameType, OpType, BundleType> =
        //   typeof stateName === "object" ? stateName : new State(stateName);
        this._states[stateName] = state;
        if (typeof this._startState === "undefined") {
            this._startState = state;
        }
        builder === null || builder === void 0 ? void 0 : builder.apply(this, [state]);
        return this;
    };
    Object.defineProperty(Fsm.prototype, "startState", {
        get: function () {
            return this._startState;
        },
        enumerable: false,
        configurable: true
    });
    Fsm.prototype.createInstance = function (currentStateName) {
        if (typeof this.startState === "undefined") {
            throw new Error("fsm must have a starting state to create a instance");
        }
        if (currentStateName === void 0) {
            currentStateName = this.startState.name;
        }
        return new FsmInstance(this, currentStateName);
    };
    Fsm.prototype.getState = function (stateName) {
        return this._states[stateName];
    };
    return Fsm;
}());
exports.Fsm = Fsm;
var FsmInstance = /** @class */ (function () {
    function FsmInstance(fsm, currentStateName) {
        this._fsm = fsm;
        if (!Object.prototype.hasOwnProperty.call(this.states, currentStateName)) {
            throw new errors_1.FSMUnknownState(currentStateName);
        }
        this._stateName = currentStateName;
    }
    FsmInstance.prototype.bundle = function (arg) {
        if (arg !== void 0) {
            this._bundle = arg;
            return this;
        }
        return this._bundle;
    };
    Object.defineProperty(FsmInstance.prototype, "states", {
        get: function () {
            return this._fsm.states;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FsmInstance.prototype, "state", {
        /**
         * set/get current state
         * @param {string} arg state name
         */
        get: function () {
            return this.states[this._stateName];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FsmInstance.prototype, "terminated", {
        get: function () {
            return this.states[this._stateName].terminated;
        },
        enumerable: false,
        configurable: true
    });
    FsmInstance.prototype.perform = function (op, args) {
        return __awaiter(this, void 0, void 0, function () {
            var originState, _a, onLeaveResults, _i, _b, cb, _c, _d, onEnterResults, _e, _f, cb, _g, _h;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        if (!this._stateName) {
                            throw new Error("Fsm has no state, do you forget to set the initialize state?");
                        }
                        originState = this.state;
                        _a = this;
                        return [4 /*yield*/, this.state.transit(op)];
                    case 1:
                        _a._stateName = _j.sent();
                        if (!Object.prototype.hasOwnProperty.call(this.states, this._stateName)) {
                            throw new errors_1.FSMUnknownState(this._stateName);
                        }
                        onLeaveResults = [];
                        if (!!(0, is_empty_1.default)(originState.onLeaveCbs)) return [3 /*break*/, 5];
                        _i = 0, _b = originState.onLeaveCbs;
                        _j.label = 2;
                    case 2:
                        if (!(_i < _b.length)) return [3 /*break*/, 5];
                        cb = _b[_i];
                        _d = (_c = onLeaveResults).push;
                        return [4 /*yield*/, Promise.resolve(cb.apply(originState, [
                                this,
                                __assign({ from: originState.name, to: this._stateName }, (typeof args === "undefined" ? {} : { actionArgs: args })),
                            ]))];
                    case 3:
                        _d.apply(_c, [(_j.sent())]);
                        _j.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        onEnterResults = [];
                        if (!!(0, is_empty_1.default)(this.state.onEnterCbs)) return [3 /*break*/, 9];
                        _e = 0, _f = this.state.onEnterCbs;
                        _j.label = 6;
                    case 6:
                        if (!(_e < _f.length)) return [3 /*break*/, 9];
                        cb = _f[_e];
                        _h = (_g = onEnterResults).push;
                        return [4 /*yield*/, Promise.resolve(cb.apply(this.state, [
                                this,
                                __assign({ from: originState.name, to: this._stateName }, (typeof args === "undefined" ? {} : { actionArgs: args })),
                            ]))];
                    case 7:
                        _h.apply(_g, [(_j.sent())]);
                        _j.label = 8;
                    case 8:
                        _e++;
                        return [3 /*break*/, 6];
                    case 9: return [2 /*return*/, {
                            onLeaveResults: onLeaveResults,
                            onEnterResults: onEnterResults,
                        }];
                }
            });
        });
    };
    FsmInstance.prototype.getOps = function () {
        if (!this._stateName) {
            throw new Error("Fsm has no state, do you forget to set the initialize state?");
        }
        return this.states[this._stateName].getOps();
    };
    FsmInstance.prototype.getRelevantStates = function () {
        return __awaiter(this, void 0, void 0, function () {
            var operableStateSet, reachableStateSet, _a, _b, _i, k, state, operable, routes, _c, _d, _e, op, nextState, reachable, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        operableStateSet = new Set();
                        reachableStateSet = new Set();
                        _a = [];
                        for (_b in (this.states))
                            _a.push(_b);
                        _i = 0;
                        _g.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 8];
                        k = _a[_i];
                        state = this.states[k];
                        operable = false;
                        routes = state.routes();
                        _c = [];
                        for (_d in routes)
                            _c.push(_d);
                        _e = 0;
                        _g.label = 2;
                    case 2:
                        if (!(_e < _c.length)) return [3 /*break*/, 6];
                        op = _c[_e];
                        nextState = routes[op];
                        _f = typeof nextState !== "object" ||
                            !nextState.test;
                        if (_f) return [3 /*break*/, 4];
                        return [4 /*yield*/, Promise.resolve(nextState.test.apply(state, [this]))];
                    case 3:
                        _f = (_g.sent());
                        _g.label = 4;
                    case 4:
                        reachable = _f;
                        if (reachable) {
                            reachableStateSet.add(typeof nextState === "object" ? nextState.to : nextState);
                        }
                        operable = operable || reachable;
                        _g.label = 5;
                    case 5:
                        _e++;
                        return [3 /*break*/, 2];
                    case 6:
                        operable && operableStateSet.add(state.name);
                        _g.label = 7;
                    case 7:
                        _i++;
                        return [3 /*break*/, 1];
                    case 8: return [2 /*return*/, {
                            operables: operableStateSet,
                            reachables: reachableStateSet,
                        }];
                }
            });
        });
    };
    return FsmInstance;
}());
exports.FsmInstance = FsmInstance;
//# sourceMappingURL=fsm.js.map