import { FsmInstance } from "./fsm";
declare type Callback<NameType extends string | number | symbol, OpType extends string | number | symbol, BundleType> = (this: State<NameType, OpType, BundleType>, fsmInstance: FsmInstance<NameType, OpType, BundleType>, context: {
    from: NameType;
    to: NameType;
    actionArgs?: unknown;
}) => Promise<unknown> | unknown;
export declare type Routes<NameType extends string | number | symbol = string, OpType extends string | number | symbol = string, BundleType = unknown> = Partial<Record<OpType, {
    to: NameType;
    test?: (this: State<NameType, OpType, BundleType>, fsmInstance?: FsmInstance<NameType, OpType, BundleType>) => boolean | Promise<boolean>;
} | NameType>>;
export declare class State<NameType extends string | number | symbol = string, OpType extends string | number | symbol = string, BundleType = unknown> {
    private _name;
    private _label?;
    private _routes;
    private _onEnterCbs;
    private _onLeaveCbs;
    constructor(name: NameType);
    get name(): NameType;
    label(): string;
    label(arg: string): State<NameType, OpType, BundleType>;
    routes(): Routes<NameType, OpType, BundleType>;
    routes(arg: Routes<NameType, OpType, BundleType>): State<NameType, OpType, BundleType>;
    transit(op: OpType): Promise<NameType>;
    onEnter(arg: Callback<NameType, OpType, BundleType>): State<NameType, OpType, BundleType>;
    get onEnterCbs(): Callback<NameType, OpType, BundleType>[];
    onLeave(arg: Callback<NameType, OpType, BundleType>): State<NameType, OpType, BundleType>;
    get onLeaveCbs(): Callback<NameType, OpType, BundleType>[];
    get terminated(): boolean;
    getOps(): Promise<OpType[]>;
}
export {};
//# sourceMappingURL=state.d.ts.map