"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.State = void 0;
var is_empty_1 = __importDefault(require("is-empty"));
var errors_1 = require("./errors");
var State = /** @class */ (function () {
    function State(name) {
        this._name = name;
        this._routes = {};
        this._onEnterCbs = [];
        this._onLeaveCbs = [];
    }
    Object.defineProperty(State.prototype, "name", {
        get: function () {
            return this._name;
        },
        enumerable: false,
        configurable: true
    });
    State.prototype.label = function (arg) {
        if (arg !== void 0) {
            this._label = arg;
            return this;
        }
        if (typeof this._label === "function") {
            return this._label.apply(this);
        }
        return this._label || this.name + "";
    };
    State.prototype.routes = function (arg) {
        if (arg === void 0) {
            return this._routes;
        }
        this._routes = arg;
        return this;
    };
    State.prototype.transit = function (op) {
        return __awaiter(this, void 0, void 0, function () {
            var ret;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ret = this._routes[op];
                        if (!ret) {
                            throw new errors_1.FSMInvalidOp(op, this);
                        }
                        if (!(typeof ret === "object" && typeof ret.test === "function")) return [3 /*break*/, 2];
                        return [4 /*yield*/, Promise.resolve(ret.test.apply(this))];
                    case 1:
                        if (!(_a.sent())) {
                            throw new errors_1.FSMInvalidOp(op, this);
                        }
                        _a.label = 2;
                    case 2: return [2 /*return*/, typeof ret === "object" ? ret.to : ret];
                }
            });
        });
    };
    State.prototype.onEnter = function (arg) {
        this._onEnterCbs.push(arg);
        return this;
    };
    Object.defineProperty(State.prototype, "onEnterCbs", {
        get: function () {
            return this._onEnterCbs;
        },
        enumerable: false,
        configurable: true
    });
    State.prototype.onLeave = function (arg) {
        this._onLeaveCbs.push(arg);
        return this;
    };
    Object.defineProperty(State.prototype, "onLeaveCbs", {
        get: function () {
            return this._onLeaveCbs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(State.prototype, "terminated", {
        get: function () {
            return (0, is_empty_1.default)(this._routes);
        },
        enumerable: false,
        configurable: true
    });
    State.prototype.getOps = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ret, _a, _b, _i, k, nextState;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        ret = [];
                        _a = [];
                        for (_b in this._routes)
                            _a.push(_b);
                        _i = 0;
                        _c.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 5];
                        k = _a[_i];
                        nextState = this._routes[k];
                        if (!(typeof nextState !== "object")) return [3 /*break*/, 2];
                        ret.push(k);
                        return [3 /*break*/, 4];
                    case 2:
                        if (!(typeof nextState.test === "function")) return [3 /*break*/, 4];
                        return [4 /*yield*/, Promise.resolve(nextState.test.apply(this))];
                    case 3:
                        if (_c.sent()) {
                            ret.push(k);
                        }
                        _c.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/, ret];
                }
            });
        });
    };
    return State;
}());
exports.State = State;
//# sourceMappingURL=state.js.map